<?php
/**
 * helper class for doing stuff
 *
 * @package     jtl_example_plugin
 * @author      Felix Moche <felix.moche@jtl-software.com
 * @copyright   2015 JTL-Software-GmbH
 */

/**
 * Class jtlExampleHelper
 */
class lpxExampleHelper
{
    /**
     * @var null|jtlExampleHelper
     */
    private static $_instance = null;

    /**
     * @var null|bool
     */
    private static $_isModern = null;

    /**
     * @var null|NiceDB
     */
    public $db = null;

    /**
     * @var null|Plugin
     */
    private $plugin = null;

    /**
     * constructor
     *
     * @param Plugin $oPlugin
     */
    public function __construct(Plugin $oPlugin)
    {
        $this->plugin = $oPlugin;
        //get database instance - do not do this, use Shop::DB()/$GLOBALS['DB'] instead
        if (self::isModern()) {
            $this->db = Shop::DB();
        } else {
            $this->db = $GLOBALS['DB'];
        }
    }

    /**
     * singleton getter
     *
     * @param Plugin $oPlugin
     * @return jtlExampleHelper
     */
    public static function getInstance(Plugin $oPlugin)
    {
        return (self::$_instance === null) ? new self($oPlugin) : self::$_instance;
    }

    /**
     * check if there is a current shop version installed
     *
     * @return bool
     */
    public static function isModern()
    {
        if (self::$_isModern === null) {
            //cache the actual value as class variable
            self::$_isModern = version_compare(JTL_VERSION, 400, '>=') && class_exists('Shop');
        }

        return self::$_isModern;
    }

 
    /**
     * modify a string with configured text
     *
     * @param string $text
     * @return string
     */
	public function shopVersion() {
		 return (self::$_isModern) ? 
				400 :					
				getShopVersion();
	} 
	
	public function shopURL() {
		 return (self::$_isModern) ? 
				Shop::getURL() :					
				gibShopURL();
	} 
	 
    public function modify($text)
    {
        return $text . (is_string($this->plugin->oPluginEinstellungAssoc_arr['modification_text']) ?
            (' ' . $this->plugin->oPluginEinstellungAssoc_arr['modification_text']) :
            '');
    }
}
